# Chatter

*An elegant chat for a more civilized age.*

![UI-Screenshot-01](https://i.imgur.com/SPeqjsu.png)

## Instructions

### Complete rewrite!

  * Now with full TextMeshPro support!
  * Configuration options have changed, please adjust back to preference.
  * Some features are missing and will be added in later updates:
    * Configuration options for text input field, toggle text buttons, world text.
    * OS font support.
    * Screenshots need to be updated.

### Features

  * Change the chat font to any built-in game fonts as well as fonts on the computer.
  * Configure the font colors for every chat message type.
  * Toggle on/off the display of chat messages by type (see below).
  * Use hot-keys (default: `PageUp`, `PageDown`) to scroll through the chat messages.
  * Chat panel will auto-hide by dimming to 0% (configurable) after 5s (configurable).
  * Use any color for the chat panel background!
  * Move **and** resize the chat panel using the mouse (see below).
  * Change change layouts on the fly between `WithHeaderRow` and `SingleRow` layouts (see below).
  * Chat filters with a dynamic UI.
  * Set the default chat message type from say to say/shout/whisper!
  * Set the default content row toggles to enable on start!

### Move/Resize/Toggle

  * Press `Escape` to show the move/resize/toggle bar.

    ![UI-Screenshot-03](https://i.imgur.com/Fv126LR.png)

### Change Message Layouts

  * The message layout can be switched at anytime in configuration manager and messages will be rebuilt immediately.

    ![UI-Screenshot-04](https://i.imgur.com/7c5T3X8.png)

### Chat Filters

  * Add/edit/remove text filters for every type of chat message using a custom drawer in ConfigurationManager.

    ![UI-Screenshot-05](https://imgur.com/vRmaiDe.png)

  - Filters only affect messages in Chatter's window.
  - Changing any text filters will only apply to **new** incoming messages.
  - This is still an *experimental* custom drawer so please report any bugs.

### Change default chat message type

  * Change the default chat message type: type `/say` or `/shout` or `/whisper` and press Enter.
  * Set the initial default message type to use at game start with config option `chatPanelDefaultMessageTypeToUse`.

### Configuration

  * Almost every component of the UI is configurable and mosty changes will be reflected immediately.

    ![UI-Screenshot-02](https://i.imgur.com/XUzlkmp.png)

### Notes

  * See source at: [GitHub/ComfyMods](https://github.com/redseiko/ComfyMods/tree/main/Chatter).
  * Looking for a chill Valheim server? [Comfy Valheim Discord](https://discord.gg/ameHJz5PFk)
  * Check out our community driven listing site at: [valheimlist.org](https://valheimlist.org/)
  * Chatter icon created by [@jenniely](https://twitter.com/jenniely) (jenniely.com)